scmChannelnames = {}

local _G = getfenv(0)

SCM_CHANNELNAMES_REGEXPS = {
	["%[Guild%]"] = "(G)",
	["%[Party%]"] = "(P)",
	["%[Raid%]"] = "(R)",
	["%[Raid Leader%]"] = "|cffff3399(|rRL|cffff3399)|r",
	["%[Raid Warning%]"] = "|cffff0000(|rRW|cffff0000)|r",
	["%[Officer%]"] = "(O)",
	["%[%d+%. WorldDefense%]"] = "|cff990066(|rWD|cff990066)|r",
	["%[%d+%. General%]"] = "|cff990066(|rGEN|cff990066)|r",
	["%[%d+%. LocalDefense%]"] = "|cff990066(|rLD|cff990066)|r",
	["%[%d+%. Trade%]"] = "|cff990066(|rT|cff990066)|r",
	["%[%d+%. GuildRecruitment %- .*%]"] = "|cff990066(|rGR|cff990066)|r",
	["%[Battleground%]"] = "|cffff3399(|rBG|cffff3399)|r",
	["%[Battleground Leader%]"] = "|cffff0000(|rBGL|cffff0000)|r",
}

local customChannels = {
	["%[%d+%.%s(%w*)%]"] = "|cff990066(|r%1|cff990066)|r",
}

local orig = {}

local function addMessage(frame, text, ...)
	if type(text) == "string" then
		for k, v in pairs(SCM_CHANNELNAMES_REGEXPS) do
			text = text:gsub(k, v)
		end
		for k, v in pairs(customChannels) do
			text = text:gsub(k, v)
		end
	end
	return orig[frame](frame, text, ...)
end

function scmChannelnames:Enable()
	for i = 1, NUM_CHAT_WINDOWS do
		local f = _G["ChatFrame"..i]
		orig[f] = f.AddMessage
		f.AddMessage = addMessage
	end
end

function scmChannelnames:Disable()
	for i = 1, NUM_CHAT_WINDOWS do
		local f = _G["ChatFrame"..i]
		if orig[f] then
			f.AddMessage = orig[f]
		end
	end
end

scmChannelnames:Enable()

