scmTimestamps = {}

SCM_TIMESTAMP_FORMAT = "%H:%M"
SCM_TIMESTAMP_COLOR = "777777"
SCM_TIMESTAMP_OUTPUT_FORMAT = "%s|r %s"

local _G = getfenv(0)
local format = nil
local orig = {}

local function addMessage(frame, text, ...)
	if type(text) == "string" then
		text = format:format(date(SCM_TIMESTAMP_FORMAT), text)
	end
	return orig[frame](frame, text, ...)
end

function scmTimestamps:Enable()
	format = "|cff"..SCM_TIMESTAMP_COLOR..SCM_TIMESTAMP_OUTPUT_FORMAT

	for i = 1, NUM_CHAT_WINDOWS do
		local c = _G["ChatFrame"..i]
		orig[c] = c.AddMessage
		c.AddMessage = addMessage
	end
end

function scmTimestamps:Disable()
	for i = 1, NUM_CHAT_WINDOWS do
		local c = _G["ChatFrame"..i]
		if orig[c] then
			c.AddMessage = orig[c]
		end
	end
end

